//    Copyright (C) 2009 Dirk Vanden Boer <dirk.vdb@gmail.com>
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "timeoperations.h"

#ifdef WIN32
	#include <Windows.h>
#else
	#include <sys/time.h>
	#include <unistd.h>
#endif
#include <assert.h>

uint64_t TimeOperations::getTimeInMilliSeconds()
{
#ifdef WIN32
	return (uint64_t) timeGetTime();
#else
    timeval timeValue;
    timezone timeZone;
    
    int32_t error = gettimeofday(&timeValue, &timeZone);
    assert(!error);
    
    return (timeValue.tv_sec * 1000) + (timeValue.tv_usec / 1000);
#endif
}

void TimeOperations::sleepMs(uint32_t ms)
{
#ifndef WIN32
    usleep(ms * 1000);
#else
    Sleep(ms);
#endif
}

