//    Copyright (C) 2009 Dirk Vanden Boer <dirk.vdb@gmail.com>
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef UI_LAYOUT_H
#define UI_LAYOUT_H

#include "signals.h"

#include <vector>

namespace Gtk
{
    class Widget;
}

namespace Gejengel
{

class GejengelPlugin;

class UILayout
{
public:
    virtual ~UILayout() {};

    virtual Gtk::Widget& getWidget() = 0;
    virtual void getPlugins(std::vector<GejengelPlugin*>& plugins) = 0;
    virtual void focusSearchField() = 0;

    SignalAlbumChanged signalAlbumChanged;
    SignalSearchChanged signalSearchChanged;

private:
};

}

#endif
