//    Copyright (C) 2009 Dirk Vanden Boer <dirk.vdb@gmail.com>
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "uilayoutfactory.h"

#include "Utils/log.h"
#include "basiclayout.h"
#include "simplealbumlayout.h"
#include "detailedalbumlayout.h"

namespace Gejengel
{

UILayout* UILayoutFactory::create(LayoutStyle style, Settings& settings, PlayQueueModel& playQueueModel, TrackModel& trackModel, AlbumModel& albumModel)
{
    switch(style)
    {
    case SimpleAlbums:
        return new SimpleAlbumLayout(settings, playQueueModel, albumModel);
    case Basic:
        return new BasicLayout(settings, playQueueModel, trackModel, albumModel);
    default:
        Log::warn("Unknown layout specified, using DetailedAlbums as fallback");
    case DetailedAlbums:
        return new DetailedAlbumLayout(settings, playQueueModel, trackModel, albumModel);
    }
}

}
